﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
/*Sample script to demonstrate how to utilize multi channel 3d audio to acutate activate haptics for direction sensing
 This example uses a stereo sound to activate left or right body haptics
*/
public class AudioToHaptic : MonoBehaviour
{
    float[] leftspectrum = new float[64];
    float[] rightspectrum = new float[64];
    float bassRatio = 0.33f;
    bool quit = false;
    float leftBass = 0;
    float rightBass = 0;
    ShockwaveManager manager;
    Shockwave_SteamVR_Haptics steamVR_manager;
    void Start()
    {
       manager = ShockwaveManager.Instance;
  //      steamVR_manager = Shockwave_SteamVR_Haptics.Instance;
        StartCoroutine("CheckAudioSignal" );
    }

    
    IEnumerator CheckAudioSignal()
    {
        while(!quit)
        //Stereo sound in left right channels
    {    AudioListener.GetSpectrumData(leftspectrum, 0, FFTWindow.Rectangular);
        AudioListener.GetSpectrumData(rightspectrum, 1, FFTWindow.Rectangular);//Inaccurate but more than enough for our purpose
             leftBass = 0;
           rightBass = 0;
            for (int i = 0; i < (int)(leftspectrum.Length * bassRatio); i++)
        {
            leftBass += leftspectrum[i];
            rightBass += rightspectrum[i];
        }
   //    Debug.Log(rightBass);

       
        ActuateRandomHaptics();
        yield return new WaitForSeconds(0.1f); //Update at 100ms. Will refresh till 600 bpm
    }
  }
void OnApplicationQuit()
{
    quit = true;
}
    public void Bassstrength(float f)
    {
        bassRatio = 0.33f * f;
    }
    
   void ActuateRandomHaptics()
    {
        int numberActuatedEachSide = (int)((leftBass+rightBass)*10);//More ACtuated at higher Intensities.Can also be set to a constant less than or equal to 10
        
        int[] hapticIndices = new int[2* numberActuatedEachSide];
        float[] hapticStrengths = new float[2* numberActuatedEachSide];
        for(int i=0;i< numberActuatedEachSide; i++)
        {
            int f = Random.Range(0, 71);
        //Picks the left side Haptics only
        while ((f<40&&(f/4)%2==1)|| (f >= 40 && (f / 8) % 2 == 0)) 
            { f = Random.Range(0, 71); }
            hapticIndices[i] = f;
            if (leftBass > 0.1f)
                hapticStrengths[i] = leftBass;
            else
                hapticStrengths[i] = 0;
        }
        for (int i = numberActuatedEachSide; i < 2* numberActuatedEachSide; i++)
        {
            int f = Random.Range(0, 71);
        //Picks the right side Haptics only
        while ((f < 40 && (f / 4) % 2 == 0) || (f >= 40 && (f / 8) % 2 == 1)) 
            { f = Random.Range(0, 72); }
            hapticIndices[i] = f;
            if (rightBass > 0.1f)
                hapticStrengths[i] = rightBass;
            else
                hapticStrengths[i] = 0;
        }
  manager.sendHapticsUpdate(hapticIndices, hapticStrengths, 2 * numberActuatedEachSide);//Use this function to activate haptics directly without using colliders
      // steamVR_manager.sendHapticsUpdate(hapticIndices, hapticStrengths, 2 * numberActuatedEachSide);
    }

}

