using System.Collections;
using System.Collections.Generic;
using UnityEngine;
//using Valve.VR;
public class Shockwave_SteamVR_Haptics : MonoBehaviour
{
    private static Shockwave_SteamVR_Haptics _instance;
    uint hipIndex = 0;
    uint numberActuatedinFrame=0;
  
    public float MaximumIntensity = 3;
  
  
    public float IntensityInsideCollider = 0.1f;
    public static Shockwave_SteamVR_Haptics Instance
    {
        get
        {
            return _instance;
        }
    }
    void Start()
    {
        if (_instance != null && _instance != this)
        {
            Destroy(this.gameObject);
        }
        else
        {
            _instance = this;
            DontDestroyOnLoad(gameObject);
        }
        SearchForShockwaveTrackers();
    }
    void Update()
    {
        numberActuatedinFrame = 0;
    }
    void SearchForShockwaveTrackers()
    {
        var str = new System.Text.StringBuilder((int)64);
        var error = ETrackedPropertyError.TrackedProp_Success;
        for (uint i = 1; i < 64; i++)
        {

            OpenVR.System.GetStringTrackedDeviceProperty(i, ETrackedDeviceProperty.Prop_SerialNumber_String, str, OpenVR.k_unMaxPropertyStringSize, ref error);

            if (str.ToString() == "Shockwave_Hip")
            {
                hipIndex = i;
                break;
            }
        }
    }
    
  public void sendHapticsUpdate(int[] hapticIndices, float[] hapticStrengths, int numberActuated)
    {if (hipIndex == 0)
            return;
        if (numberActuated > 9)
            numberActuated = 9;
        for (uint i = 0; i <numberActuated; i++)
        { OpenVR.System.TriggerHapticPulse(hipIndex + i+1, 0,(ushort) ((hapticIndices[i]*50)+ (hapticStrengths[i]*49))); }

    }

   public void sendHapticsWithPosition(int hapticIndex, float hapticStrength, float position)
    {
        if (hipIndex == 0)
            return;
        if (numberActuatedinFrame >= 8)
            return;
        if(numberActuatedinFrame==0)
        OpenVR.System.TriggerHapticPulse(hipIndex , 0, 1000);
        OpenVR.System.TriggerHapticPulse(hipIndex + numberActuatedinFrame + 1, 0, (ushort)((hapticIndex * 50) + (position * 49)));
        OpenVR.System.TriggerHapticPulse(hipIndex + numberActuatedinFrame + 2, 0, (ushort)((hapticIndex * 50) + (hapticStrength * 49)));
     
        numberActuatedinFrame += 2;
    }
    public void SetMaximumIntensity(float maximumIntensity)
    {
        if (hipIndex == 0)
            return;
        MaximumIntensity = maximumIntensity;
        OpenVR.System.TriggerHapticPulse(hipIndex, 0, (ushort)(2 +( maximumIntensity*10)));
    }

    public void intensityInsideCollider(float f)
    {
        IntensityInsideCollider = f;
    }
  
}
